#pragma once

namespace AMDiS
{
  template <class GridView, class Element, class Operators, class ElementAssembler>
  void assembleOperators(
      GridView const& gridView,
      Element const& element,
      Operators& operators,
      ElementAssembler const& localAssembler)
  {
    // assemble element operators
    localAssembler(element, operators.element);

    // assemble intersection operators
    if (!operators.intersection.empty()
        || (!operators.boundary.empty() && element.hasBoundaryIntersections()))
    {
      for (auto const& intersection : intersections(gridView, element)) {
        if (intersection.boundary())
          localAssembler(intersection, operators.boundary);
        else
          localAssembler(intersection, operators.intersection);
      }
    }
  }

} // end namespace AMDiS
