#pragma once

#include <string>

#include <amdis/Initfile.hpp>
#include <amdis/Output.hpp>
#include <amdis/utility/Filesystem.hpp>

namespace AMDiS
{
  // forward declaration
  class AdaptInfo;

  class FileWriterInterface
  {
  public:
    explicit FileWriterInterface(std::string base)
    {
      filename_ = "solution";
      Parameters::get(base + "->filename", filename_);
      dir_ = "output";
      Parameters::get(base + "->output directory", dir_);
      name_ = "solution";
      Parameters::get(base + "->name", name_);
    }

    virtual ~FileWriterInterface() = default;


    // pure virtual method to be implemented by derived classes
    virtual void writeFiles(AdaptInfo& adaptInfo, bool force) = 0;


    std::string getFilename() const
    {
      return filename_;
    }

    void setFilename(std::string const& filename)
    {
      filename_ = filename;
    }

    std::string getName() const
    {
      return name_;
    }

  protected:
    std::string filename_;
    std::string dir_;
    std::string name_;
  };

} // end namespace AMDiS
